
# variogram with annual means
library(dplyr)

obs_annual_mean <- df_obs_sub %>%
  dplyr::summarise(across(where(is.numeric), ~ mean(.x, na.rm = TRUE)))

# transpose 
obs_annual_mean_t <- data.frame(ref_obs = colnames(obs_annual_mean),
                                obs = as.numeric(obs_annual_mean[1,]))




stations <- data.frame(lat=local_stations@coords[,2],
                 lon=local_stations@coords[,1],
                 ref_obs=local_stations@data$ref_obs) 


df <- merge(stations, obs_annual_mean_t, by="ref_obs")


df <- na.omit(df) 

coordinates(df)        <- ~lon+lat
sp::proj4string(df)    <- crs_latlon

#config the coordinates in UTM
if (compute_in_UTM) {
  df <- spTransform(df, sp::CRS(crs_utm))
} else {
  sp::proj4string(df) <- crs_latlon
}

# Compute variogram
variogram <- automap::autofitVariogram(formula=obs~1,input_data=df, verbose=FALSE)

saveRDS(variogram, "/esarchive/scratch/ccarnere/RScripts/results_regional_2022/results_gene_o3/output/variogram.RDS")
saveRDS(df, "/esarchive/scratch/ccarnere/RScripts/results_regional_2022/results_gene_o3/output/df_variogram.RDS")